# DetachNetworkInterface

## 1. API Description

This API (DetachNetworkInterface) is used to detach the vNIC from the instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">The instance state should be Running.</mark>
* <mark style="color:blue;">The vNIC state should be</mark> <mark style="color:blue;">`USED`</mark><mark style="color:blue;">.</mark>
* <mark style="color:blue;">Operations on the primary vNIC are not supported.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description     |
| -------------- | -------- | ------ | --------------- |
| nicId          | Yes      | String | ID of the vNIC. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Detach the vNIC.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DetachNetworkInterface
<Common Request Params>

Request:
{
  "nicId": "XXX"
}

Response:
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                        | Description                                                                                          |
| ---------------- | ------------------------------------------------- | ---------------------------------------------------------------------------------------------------- |
| 409              | INVALID\_NIC\_LB\_ASSOCIATED                      | Operation is not supported because the private IP is associated with a load balancer backend server. |
| 404              | INVALID\_NIC\_NOT\_FOUND                          | vNIC does not exist.                                                                                 |
| 409              | INVALID\_NIC\_PRIMARY\_CANT\_DETACH               | Operations on the primary vNIC are not supported.                                                    |
| 400              | INVALID\_NIC\_STATUS                              | Current vNIC state does not allow this operation.                                                    |
| 400              | OPERATION\_DENIED\_INSTANCE\_STATUS\_NOT\_SUPPORT | Current instance state does not allow this operation.                                                |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/zec/vnic/detachnetworkinterface.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
